SystemOrganization addCategory: #'Xenon-Tests'!
SystemOrganization addCategory: #'Xenon-Tests-Scenarios'!
SystemOrganization addCategory: #'Xenon-Tests-Semantic'!

TestCase subclass: #XeAbstractTest
	instanceVariableNames: 'cg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeAbstractTest methodsFor: 'convenience' stamp: 'BernardoContreras 5/25/2012 21:20'!
assertTranslationOf: aClass
	" assert expected equals the translation of aClass"

	| expectedString actualString |
	cg addClass: aClass.
	actualString := cg codeString.
	expectedString := aClass expected contents.
	self assert: expectedString = actualString description: (self browse: aClass)! !

!XeAbstractTest methodsFor: 'convenience' stamp: 'BernardoContreras 5/25/2012 21:25'!
browse: aClass
	"browse this scenario in order to know what when wrong"

	^ XeScenarioBrowser asString , ' browse: ' , aClass asString! !

!XeAbstractTest methodsFor: 'running' stamp: 'BernardoContreras 4/11/2012 02:23'!
setUp
	cg := XeCodeGenerator new! !

XeAbstractTest subclass: #XeTranslateFunctionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeTranslateFunctionTest commentStamp: 'BernardoContreras 4/5/2012 15:12' prior: 0!
To test the translation of functions
!

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/12/2012 22:49'!
testTranslateFunctionCallAnotherFunction
	self assertTranslationOf: XeFunctionCallAnotherFunctionScenario! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:23'!
testTranslateFunctionCallAnotherFunctionWithTwoArguments
	self assertTranslationOf: XeFunctionCallAnotherFunctionWithTwoArgumentsScenario! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:25'!
testTranslateFunctionThatReturnsZero
	self assertTranslationOf: XeFunctionThatReturnsZeroScenario! !

!XeTranslateFunctionTest methodsFor: 'testing errors' stamp: 'BernardoContreras 4/15/2012 01:30'!
testTranslateFunctionWhenItHasManyReturnTypes
	self should: [ cg addClass: XeFunctionThatHasManyReturnTypeScenario ] raise: XeTooManyReturnTypesError! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:27'!
testTranslateFunctionWhenReturnTypeIsDefault
	self assertTranslationOf: XeFunctionWithDefaultReturnTypeScenario! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:29'!
testTranslateFunctionWhenReturnTypeIsInteger
	self assertTranslationOf: XeFunctionWhenReturnTypeIsIntegerScenario! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:34'!
testTranslateFunctionWithOneArgument
	self assertTranslationOf: XeFunctionWithOneArgumentScenario! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:41'!
testTranslateFunctionWithOneIntegerArgument
	self assertTranslationOf: XeFunctionWithOneIntegerArgumentScenario! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:43'!
testTranslateFunctionWithTwoArguments
	self assertTranslationOf: XeFunctionWithTwoArgumentsScenario! !

XeAbstractTest subclass: #XeTranslateIfStatementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeTranslateIfStatementTest commentStamp: 'BernardoContreras 4/11/2012 02:33' prior: 0!
To test the translation of the if statement!

!XeTranslateIfStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 5/25/2012 19:08'!
testTranslateIfFalseAsArgumentInFunctionCallStatement
	self assertTranslationOf: XeIfFalseAsArgumentInFunctionCallScenario ! !

!XeTranslateIfStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 5/16/2012 22:47'!
testTranslateIfFalseAsArgumentInReturnStatement
	self assertTranslationOf: XeIfFalseAsArgumentInReturnScenario! !

!XeTranslateIfStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 4/28/2012 18:18'!
testTranslateIfFalseIfTrueStatement
	self assertTranslationOf: XeIfFalseIfTrueScenario! !

!XeTranslateIfStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 4/22/2012 04:31'!
testTranslateIfFalseStatement
	self assertTranslationOf: XeIfFalseScenario! !

!XeTranslateIfStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 5/25/2012 20:00'!
testTranslateIfTrueAsArgumentInFunctionCallStatement
	self assertTranslationOf: XeIfTrueAsArgumentInFunctionCallScenario ! !

!XeTranslateIfStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 5/20/2012 16:42'!
testTranslateIfTrueAsArgumentInReturnStatement
	self assertTranslationOf: XeIfTrueAsArgumentInReturnScenario! !

!XeTranslateIfStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 4/24/2012 23:44'!
testTranslateIfTrueIfFalseStatement
	self assertTranslationOf: XeIfTrueIfFalseScenario! !

!XeTranslateIfStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 4/12/2012 20:48'!
testTranslateIfTrueStatement
	self assertTranslationOf: XeIfTrueScenario! !

XeAbstractTest subclass: #XeTranslateWhileStatementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeTranslateWhileStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 5/12/2012 18:10'!
testTranslateDoWhileFalseStatement
	self assertTranslationOf: XeDoWhileFalseScenario! !

!XeTranslateWhileStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 5/13/2012 04:19'!
testTranslateDoWhileTrueStatement
	self assertTranslationOf: XeDoWhileTrueScenario! !

!XeTranslateWhileStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 5/11/2012 22:48'!
testTranslateWhileFalseDoStatement
	self assertTranslationOf: XeWhileFalseDoScenario! !

!XeTranslateWhileStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 5/12/2012 01:51'!
testTranslateWhileFalseStatement
	self assertTranslationOf: XeWhileFalseScenario! !

!XeTranslateWhileStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 5/1/2012 23:45'!
testTranslateWhileTrueDoStatement
	self assertTranslationOf: XeWhileTrueDoScenario! !

!XeTranslateWhileStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 5/1/2012 23:45'!
testTranslateWhileTrueStatement
	self assertTranslationOf: XeWhileTrueScenario! !

TestCase subclass: #XeCLiteralValueTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeCLiteralValueTest commentStamp: 'BernardoContreras 4/11/2012 19:47' prior: 0!
To test the translation of objects to a C literal value.
!

!XeCLiteralValueTest methodsFor: 'testing' stamp: 'BernardoContreras 4/22/2012 04:06'!
testCharTranslateToQuotedChar
	| expected actual |
	expected := '''' , 'e' , ''''.
	actual := $e asCLiteralValue.
	self assert: expected equals: actual! !

!XeCLiteralValueTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 19:49'!
testFalseTranslateToZero
	self assert: '0' equals: false asCLiteralValue! !

!XeCLiteralValueTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 20:18'!
testNilTranslateToNull
	self assert: 'null' equals: nil asCLiteralValue! !

!XeCLiteralValueTest methodsFor: 'testing' stamp: 'BernardoContreras 4/13/2012 00:17'!
testStringTranslateToQuotedString
	| expected actual |
	expected := '"' , 'aString' , '"'.
	actual := 'aString' asCLiteralValue.
	self assert: expected equals: actual! !

!XeCLiteralValueTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 19:51'!
testTrueTranslateToZero
	self assert: '1' equals: true asCLiteralValue! !

TestCase subclass: #XeSemanticTest
	instanceVariableNames: 'instVar'
	classVariableNames: 'ClassVar'
	poolDictionaries: ''
	category: 'Xenon-Tests-Semantic'!

!XeSemanticTest commentStamp: 'BernardoContreras 5/25/2012 18:17' prior: 0!
stolen from AST-Semantic!

!XeSemanticTest class methodsFor: 'accessing' stamp: 'BernardoContreras 5/25/2012 18:23'!
packageNamesUnderTest
	^ #('Xenon-Core')! !

!XeSemanticTest methodsFor: 'utilities' stamp: 'BernardoContreras 5/25/2012 16:46'!
parseExpression: aString
	^ (RBParser parseExpression: aString)
		xeAnnotateInClass: self class;
		yourself! !

!XeSemanticTest methodsFor: 'utilities' stamp: 'BernardoContreras 5/25/2012 16:46'!
parseMethod: aString
	^ (RBParser parseMethod: aString)
		xeAnnotateInClass: self class;
		yourself! !

!XeSemanticTest methodsFor: 'testing' stamp: 'BernardoContreras 5/25/2012 16:57'!
testAccessors
	| tree binding |
	tree := self parseExpression: '| var | var'.
	binding := tree scope bindingOf: 'var'.
	self assert: binding node = tree temporaries first.
	self assert: binding accessors size = 1.
	self assert: binding accessors first = tree statements first.
	self assert: binding readers isEmpty.
	self assert: binding writers isEmpty! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 5/25/2012 16:58'!
testBlockArgumentBinding
	| tree binding |
	tree := self parseExpression: '[ :arg | ]'.
	binding := tree arguments first xeVariableBinding.
	
	self assert: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self deny: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self deny: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self deny: binding isAccessed.
	self assert: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self assert: binding isReadonly.
	
	self assert: binding name = 'arg'.
	self assert: binding printString isString.
	self assert: binding node = tree arguments first.
	self assert: binding scope = tree scope! !

!XeSemanticTest methodsFor: 'testing-scopes' stamp: 'BernardoContreras 5/25/2012 16:58'!
testBlockScope
	| tree scope |
	tree := self parseExpression: '[ :arg | | tmp | ]'.
	scope := tree scope.
	
	self assert: scope isBlockScope.
	self deny: scope isLiteralScope.
	self deny: scope isMethodScope.
	self deny: scope isRootScope.
	self deny: scope isVariableScope.
	
	self assert: scope node = tree.
	
	self assert: (scope lookup: 'arg') isArgumentBinding.
	self assert: (scope lookup: 'arg') scope = scope.
	self assert: (scope lookup: 'arg') name = 'arg'.

	self assert: (scope lookup: 'tmp') isTemporaryBinding.
	self assert: (scope lookup: 'tmp') scope = scope.
	self assert: (scope lookup: 'tmp') name = 'tmp'.

	self should: [ scope lookup: 'something' ] raise: Error.
	self assert: (scope lookup: 'something' ifAbsent: [ #nothing ]) = #nothing ! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 5/25/2012 16:59'!
testBlockTemporaryBinding
	| tree binding |
	tree := self parseExpression: '[ | tmp | ]'.
	binding := tree body temporaries first xeVariableBinding.
	
	self deny: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self deny: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self assert: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self deny: binding isAccessed.
	self assert: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self deny: binding isReadonly.
	
	self assert: binding name = 'tmp'.
	self assert: binding printString isString.
	self assert: binding node = tree body temporaries first.
	self assert: binding scope = tree scope! !

!XeSemanticTest methodsFor: 'testing-fixtures' stamp: 'BernardoContreras 5/25/2012 17:49'!
testCascadeReceiver
	| tree receiver receiver1 receiver2 |
	tree := self parseExpression: 'self foo; bar'.
	receiver := tree receiver.
	receiver1 := tree messages first receiver.
	receiver2 := tree messages last receiver.
	
	self assert: receiver xeVariableBinding = receiver1 xeVariableBinding.
	self assert: receiver xeVariableBinding = receiver2 xeVariableBinding! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 5/25/2012 17:49'!
testClassVariableBinding
	| tree binding |
	tree := self parseExpression: 'ClassVar'.
	binding := tree xeVariableBinding.
	
	self deny: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self assert: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self deny: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self assert: binding isAccessed.
	self deny: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self deny: binding isReadonly.
	
	self assert: binding name = 'ClassVar'.
	self assert: binding printString isString.
	self assert: binding binding = (self class bindingOf: 'ClassVar').
	self assert: binding scope notNil! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 5/25/2012 17:55'!
testGlobalVariableBinding
	| tree binding |
	tree := self parseExpression: self class name.
	binding := tree xeVariableBinding.
	
	self deny: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self assert: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self deny: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self assert: binding isAccessed.
	self deny: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self deny: binding isReadonly.
	
	self assert: binding name = self class name.
	self assert: binding printString isString.
	self assert: binding binding = (self class bindingOf: self class name).
	self assert: binding scope notNil! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 5/25/2012 17:08'!
testInstanceVariableBinding
	| tree binding |
	tree := self parseExpression: 'instVar'.
	binding := tree xeVariableBinding.
	
	self deny: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self assert: binding isInstanceBinding.
	self deny: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self deny: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self assert: binding isAccessed.
	self deny: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self deny: binding isReadonly.
	
	self assert: binding name = 'instVar'.
	self assert: binding printString isString.
	self assert: binding index = (self class allInstVarNames indexOf: 'instVar').
	self assert: binding scope notNil! !

!XeSemanticTest methodsFor: 'testing-scopes' stamp: 'BernardoContreras 5/25/2012 16:45'!
testLiteralScope
	| scope literals |
	scope := RBLiteralScope
		owner: RBRootScope new
		class: RBMessageNode.
	
	self deny: scope isBlockScope.
	self assert: scope isLiteralScope.
	self deny: scope isMethodScope.
	self deny: scope isRootScope.
	self deny: scope isVariableScope.
	
	self assert: scope theClass = RBMessageNode.
	
	literals := OrderedCollection new.
	literals addAll: (RBMessageNode allClassVarNames).
	literals addAll: (RBProgramNode allSubclasses collect: [ :each | each name ]).
	literals do: [ :name |
		self assert: (scope lookup: name) isLiteralBinding.
		self assert: (scope lookup: name) scope = scope.
		self assert: (scope lookup: name) name = name ].
	
	self assert: (scope lookup: 'self') scope = scope owner.
	self assert: (scope lookup: 'super') scope = scope owner.
	self assert: (scope lookup: 'thisContext') scope = scope owner.

	self should: [ scope lookup: 'something' ] raise: Error.
	self assert: (scope lookup: 'something' ifAbsent: [ #nothing ]) = #nothing ! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 5/25/2012 17:55'!
testMethodArgumentBinding
	| tree binding |
	tree := self parseMethod: 'foo: arg'.
	binding := tree arguments first xeVariableBinding.
	
	self assert: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self deny: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self deny: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self deny: binding isAccessed.
	self assert: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self assert: binding isReadonly.
	
	self assert: binding name = 'arg'.
	self assert: binding printString isString.
	self assert: binding node = tree arguments first.
	self assert: binding scope = tree scope! !

!XeSemanticTest methodsFor: 'testing-scopes' stamp: 'BernardoContreras 5/25/2012 17:56'!
testMethodScope
	| tree scope |
	tree := self parseMethod: 'foo: arg | tmp |'.
	scope := tree scope.
	
	self deny: scope isBlockScope.
	self deny: scope isLiteralScope.
	self assert: scope isMethodScope.
	self deny: scope isRootScope.
	self deny: scope isVariableScope.
	
	self assert: scope node = tree.
	
	self assert: (scope lookup: 'arg') isArgumentBinding.
	self assert: (scope lookup: 'arg') scope = scope.
	self assert: (scope lookup: 'arg') name = 'arg'.

	self assert: (scope lookup: 'tmp') isTemporaryBinding.
	self assert: (scope lookup: 'tmp') scope = scope.
	self assert: (scope lookup: 'tmp') name = 'tmp'.

	self should: [ scope lookup: 'something' ] raise: Error.
	self assert: (scope lookup: 'something' ifAbsent: [ #nothing ]) = #nothing ! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 5/25/2012 17:56'!
testMethodTemporaryBinding
	| tree binding |
	tree := self parseMethod: 'foo | tmp |'.
	binding := tree body temporaries first xeVariableBinding.
	
	self deny: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self deny: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self assert: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self deny: binding isAccessed.
	self assert: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self deny: binding isReadonly.
	
	self assert: binding name = 'tmp'.
	self assert: binding printString isString.
	self assert: binding node = tree body temporaries first.
	self assert: binding scope = tree scope! !

!XeSemanticTest methodsFor: 'testing' stamp: 'BernardoContreras 5/25/2012 16:56'!
testMissing
	| tree |
	tree := self parseExpression: 'a'.

	self 
		should: [ RBVariableNode new scope ]
		raise: XeSemanticAnnotationMissing.
	self
		shouldnt: [ tree scope ]
		raise: XeSemanticAnnotationMissing.
		
	self
		should: [ RBVariableNode new xeVariableBinding ]
		raise: XeSemanticAnnotationMissing.
	self
		shouldnt: [ tree xeVariableBinding ]
		raise: XeSemanticAnnotationMissing.
		
	self deny: RBVariableNode new hasVariableBinding.
	self assert: tree hasXeVariableBinding! !

!XeSemanticTest methodsFor: 'testing-fixtures' stamp: 'BernardoContreras 5/25/2012 18:00'!
testMultipleScopes
	| tree block1 variable1 block2 variable2 |
	tree := self parseExpression: '[ :a | a ]. [ | a | a ]'.
	block1 := tree statements first.
	variable1 := block1 arguments first.
	block2 := tree statements last.
	variable2 := block2 body temporaries first.
	
	self deny: variable1 xeVariableBinding = variable2 xeVariableBinding.
	self assert: variable1 xeVariableBinding = block1 body statements first xeVariableBinding.
	
	self deny: variable2 xeVariableBinding = variable1 xeVariableBinding.
	self assert: variable2 xeVariableBinding = block2 body statements first xeVariableBinding.
	
	self assert: variable1 xeVariableBinding scope = block1 scope.
	self assert: variable2 xeVariableBinding scope = block2 scope.! !

!XeSemanticTest methodsFor: 'testing' stamp: 'BernardoContreras 5/25/2012 18:01'!
testReadWriter
	| tree binding |
	tree := self parseExpression: '| var | ^ var := 1'.
	binding := tree scope bindingOf: 'var'.
	self assert: binding node = tree temporaries first.
	self assert: binding accessors size = 1.
	self assert: binding accessors first = tree statements first value variable.
	self assert: binding readers size = 1.
	self assert: binding readers first = tree statements first value variable.
	self assert: binding writers size = 1.
	self assert: binding writers first = tree statements first value variable.! !

!XeSemanticTest methodsFor: 'testing' stamp: 'BernardoContreras 5/25/2012 18:03'!
testReader
	| tree binding |
	tree := self parseExpression: '| var | ^ var'.
	binding := tree scope bindingOf: 'var'.
	self assert: binding node = tree temporaries first.
	self assert: binding accessors size = 1.
	self assert: binding accessors first = tree statements first value.
	self assert: binding readers size = 1.
	self assert: binding readers first = tree statements first value.
	self assert: binding writers isEmpty! !

!XeSemanticTest methodsFor: 'testing-scopes' stamp: 'BernardoContreras 5/25/2012 16:45'!
testRootScope
	| scope |
	scope := RBRootScope new.
	
	self deny: scope isBlockScope.
	self deny: scope isLiteralScope.
	self deny: scope isMethodScope.
	self assert: scope isRootScope.
	self deny: scope isVariableScope.
	
	self assert: (scope lookup: 'self') isSelfBinding.
	self assert: (scope lookup: 'self') scope = scope.

	self assert: (scope lookup: 'super') isSuperBinding.
	self assert: (scope lookup: 'super') scope = scope.

	self assert: (scope lookup: 'thisContext') isContextBinding.
	self assert: (scope lookup: 'thisContext') scope = scope.

	self should: [ scope lookup: 'something' ] raise: Error.
	self assert: (scope lookup: 'something' ifAbsent: [ #nothing ]) = #nothing ! !

!XeSemanticTest methodsFor: 'testing-fixtures' stamp: 'BernardoContreras 5/25/2012 18:05'!
testShadowedVariables
	| tree variable1 variable2 variable3 variable4 |
	tree := self parseExpression: '| a | [ :a | a ]. a'.
	variable1 := tree temporaries first.
	variable2 := tree statements first arguments first.
	variable3 := tree statements first body statements first.
	variable4 := tree statements last.
	
	self deny: variable1 xeVariableBinding isShadowing.
	self assert: variable2 xeVariableBinding isShadowing.
	self assert: variable3 xeVariableBinding isShadowing.
	self deny: variable4 xeVariableBinding isShadowing.
	
	self assert: variable1 xeVariableBinding = variable4 xeVariableBinding.
	self deny: variable1 xeVariableBinding = variable3 xeVariableBinding.
	self deny: variable2 xeVariableBinding = variable4 xeVariableBinding.
	self assert: variable2 xeVariableBinding = variable3 xeVariableBinding.
	! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 5/25/2012 18:06'!
testSpecialContextBinding
	| tree binding |
	tree := self parseExpression: 'thisContext'.
	binding := tree xeVariableBinding.
	
	self deny: binding isArgumentBinding.
	self assert: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self deny: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self deny: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self assert: binding isAccessed.
	self deny: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self assert: binding isReadonly.
	
	self assert: binding name = 'thisContext'.
	self assert: binding printString isString.
	self deny: binding scope isNil! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 5/25/2012 18:06'!
testSpecialSelfBinding
	| tree binding |
	tree := self parseExpression: 'self'.
	binding := tree xeVariableBinding.
	
	self deny: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self deny: binding isLiteralBinding.
	self assert: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self deny: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self assert: binding isAccessed.
	self deny: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self assert: binding isReadonly.
	
	self assert: binding name = 'self'.
	self assert: binding printString isString.
	self deny: binding scope isNil! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 5/25/2012 18:06'!
testSpecialSuperBinding
	| tree binding |
	tree := self parseExpression: 'super'.
	binding := tree xeVariableBinding.
	
	self deny: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self deny: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self assert: binding isSuperBinding.
	self deny: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self assert: binding isAccessed.
	self deny: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self assert: binding isReadonly.
	
	self assert: binding name = 'super'.
	self assert: binding printString isString.
	self deny: binding scope isNil! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 5/25/2012 18:11'!
testUndeclaredBinding
	| tree binding |
	tree := self parseExpression: '[ undecl ]'.
	binding := tree body statements first xeVariableBinding.
	
	self deny: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self deny: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self deny: binding isTemporaryBinding.
	self assert: binding isUndeclaredBinding.
	
	self assert: binding isAccessed.
	self deny: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self deny: binding isReadonly.
	
	self assert: binding name = 'undecl'.
	self assert: binding printString isString.
	self assert: binding node = tree body statements first.
	self assert: binding scope notNil! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 5/25/2012 18:19'!
testUndeclaredHandled
	| seen tree binding |
	seen := false.
	tree := [ self parseExpression: '[ undecl ]' ]
		on: XeUndeclaredVariableNotification
		do: [ :err |
			seen := true.
			err resume: (XeLiteralBinding binding: (err node name -> 123)) ].
	self assert: seen.
	binding := tree body statements first xeVariableBinding.
	
	self deny: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self assert: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self deny: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self assert: binding isAccessed.
	self deny: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self deny: binding isReadonly.
	
	self assert: binding name = 'undecl'.
	self assert: binding printString isString.
	self assert: binding binding key = 'undecl'.
	self assert: binding binding value = 123.
	self assert: binding scope notNil! !

!XeSemanticTest methodsFor: 'testing-scopes' stamp: 'BernardoContreras 5/25/2012 16:45'!
testVariableScope
	| scope |
	scope := RBVariableScope
		owner: RBRootScope new
		class: RBMessageNode.
	
	self deny: scope isBlockScope.
	self deny: scope isLiteralScope.
	self deny: scope isMethodScope.
	self deny: scope isRootScope.
	self assert: scope isVariableScope.
	
	self assert: scope theClass = RBMessageNode.
	
	RBMessageNode allInstVarNames keysAndValuesDo: [ :index :name |
		self assert: (scope lookup: name) isInstanceBinding.
		self assert: (scope lookup: name) scope = scope.
		self assert: (scope lookup: name) name = name.
		self assert: (scope lookup: name) index = index ].
	
	self assert: (scope lookup: 'self') scope = scope owner.
	self assert: (scope lookup: 'super') scope = scope owner.
	self assert: (scope lookup: 'thisContext') scope = scope owner.

	self should: [ scope lookup: 'something' ] raise: Error.
	self assert: (scope lookup: 'something' ifAbsent: [ #nothing ]) = #nothing ! !

!XeSemanticTest methodsFor: 'testing' stamp: 'BernardoContreras 5/25/2012 18:12'!
testWriter
	| tree binding |
	tree := self parseExpression: '| var | var := 1'.
	binding := tree scope bindingOf: 'var'.
	self assert: binding node = tree temporaries first.
	self assert: binding accessors size = 1.
	self assert: binding accessors first = tree statements first variable.
	self assert: binding readers isEmpty.
	self assert: binding writers size = 1.
	self assert: binding writers first = tree statements first variable! !

TestCase subclass: #XeTypeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeTypeTest methodsFor: 'testing' stamp: 'BernardoContreras 4/22/2012 01:50'!
testEquality
	self assert: #void asXeType = #void asXeType! !

Object subclass: #XeDoWhileFalseScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeDoWhileFalseScenario commentStamp: 'BernardoContreras 5/12/2012 20:22' prior: 0!
[ stmt. ] doWhileFalse: [ stmt2. lastStmt. ]
==>
do {
	stmt;
		{	
		stmt2;
		if (lastStmt) break;
		}
	} while (1);
 
!

!XeDoWhileFalseScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/25/2012 21:16'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'do {'.
	expected indentation: 2.
	expected << '2;'.
	expected indentation: 3.
	expected << '{'.
	expected << 'if (0) break;'.
	expected << '}'.
	expected indentation: 2.
	expected << '} while (1);'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeDoWhileFalseScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/12/2012 20:26'!
foo
	<returnType: #void>
	[ 2 ] doWhileFalse: [ false ]
 ! !

Object subclass: #XeDoWhileTrueScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeDoWhileTrueScenario commentStamp: 'BernardoContreras 5/12/2012 20:22' prior: 0!
[ stmt. ] doWhileTrue: [ stmt2. lastStmt. ]
==>
do {
	stmt;
		{	
		stmt2;
		if (!!(lastStmt)) break;
		}
	} while (1);
 
!

!XeDoWhileTrueScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/12/2012 20:29'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'do {'.
	expected indentation: 2.
	expected << '2;'.
	expected indentation: 3.
	expected << '{'.
	expected << 'if (!!(1)) break;'.
	expected << '}'.
	expected indentation: 2.
	expected << '} while (1);'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeDoWhileTrueScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/12/2012 20:26'!
foo
	<returnType: #void>
	[ 2 ] doWhileTrue: [ true ]
 ! !

Object subclass: #XeFunctionCallAnotherFunctionScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionCallAnotherFunctionScenario commentStamp: '<historical>' prior: 0!
A function that calls another function.
!

!XeFunctionCallAnotherFunctionScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 03:09'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int bar(int y);'.
	expected << 'int foo(int x);'.
	expected << 'int bar(int y){'.
	expected indentation: 1.
	expected << 'return y + 1;'.
	expected indentation: 0.
	expected << '}'.
	expected << 'int foo(int x){'.
	expected indentation: 1.
	expected << 'return bar(x);'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeFunctionCallAnotherFunctionScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/8/2012 00:42'!
bar: y
	<returnType: #int>
	<var: #y type: #int>
	^ y + 1! !

!XeFunctionCallAnotherFunctionScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/8/2012 00:41'!
foo: x
	<returnType: #int>
	<var: #x type: #int>
	^ self bar: x! !

Object subclass: #XeFunctionCallAnotherFunctionWithTwoArgumentsScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionCallAnotherFunctionWithTwoArgumentsScenario commentStamp: '<historical>' prior: 0!
A function that calls another function with two arguments.!

!XeFunctionCallAnotherFunctionWithTwoArgumentsScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 03:08'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int barand(int z, int y);'.
	expected << 'int foo(int x);'.
	expected << 'int barand(int z, int y){'.
	expected indentation: 1.
	expected << 'return y + z;'.
	expected indentation: 0.
	expected << '}'.
	expected << 'int foo(int x){'.
	expected indentation: 1.
	expected << 'return barand(x, 5);'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeFunctionCallAnotherFunctionWithTwoArgumentsScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/9/2012 04:18'!
bar: z and: y
	<returnType: #int>
	<var: #z type: #int>
	<var: #y type: #int>
	^ y + z! !

!XeFunctionCallAnotherFunctionWithTwoArgumentsScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/9/2012 04:19'!
foo: x
	<returnType: #int>
	<var: #x type: #int>
	^ self bar: x and: 5! !

Object subclass: #XeFunctionThatHasManyReturnTypeScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionThatHasManyReturnTypeScenario commentStamp: 'BernardoContreras 4/7/2012 20:19' prior: 0!
A function that has many return types.
!

!XeFunctionThatHasManyReturnTypeScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #int>
	<returnType: #void>
! !

Object subclass: #XeFunctionThatReturnsZeroScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionThatReturnsZeroScenario commentStamp: 'BernardoContreras 4/7/2012 20:23' prior: 0!
A function that returns zero
!

!XeFunctionThatReturnsZeroScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 03:06'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int foo(void);'.
	expected << 'int foo(void){'.
	expected indentation: 1.
	expected << 'return 0;'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeFunctionThatReturnsZeroScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/5/2012 18:49'!
foo
	<returnType: #int>
	^ 0
		
! !

Object subclass: #XeFunctionWhenReturnTypeIsIntegerScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionWhenReturnTypeIsIntegerScenario commentStamp: 'BernardoContreras 4/7/2012 20:23' prior: 0!
A function when return type is integer.
!

!XeFunctionWhenReturnTypeIsIntegerScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:28'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int foo(void);'.
	expected << 'int foo(void){'.
	expected << '}'.
	^ expected! !

!XeFunctionWhenReturnTypeIsIntegerScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #int>
! !

Object subclass: #XeFunctionWithDefaultReturnTypeScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionWithDefaultReturnTypeScenario commentStamp: 'BernardoContreras 4/5/2012 15:19' prior: 0!
A function with a default return type.
!

!XeFunctionWithDefaultReturnTypeScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:27'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'sqInt foo(void);'.
	expected << 'sqInt foo(void){'.
	expected << '}'.
	^ expected! !

!XeFunctionWithDefaultReturnTypeScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
! !

Object subclass: #XeFunctionWithOneArgumentScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionWithOneArgumentScenario commentStamp: 'BernardoContreras 4/5/2012 15:24' prior: 0!
A function with one argument.
!

!XeFunctionWithOneArgumentScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/13/2012 00:16'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int foo(sqInt x);'.
	expected << 'int foo(sqInt x){'.
	expected << '}'.
	^ expected! !

!XeFunctionWithOneArgumentScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/2/2012 01:57'!
foo: x
	<returnType: #int>
! !

Object subclass: #XeFunctionWithOneIntegerArgumentScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionWithOneIntegerArgumentScenario commentStamp: 'BernardoContreras 4/5/2012 17:06' prior: 0!
A function with one integer argument.
!

!XeFunctionWithOneIntegerArgumentScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:41'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int foo(int x);'.
	expected << 'int foo(int x){'.
	expected << '}'.
	^ expected! !

!XeFunctionWithOneIntegerArgumentScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/5/2012 16:05'!
foo: x
	<returnType: #int>
	<var: #x type: #int>
	! !

Object subclass: #XeFunctionWithTwoArgumentsScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionWithTwoArgumentsScenario commentStamp: 'BernardoContreras 4/7/2012 20:20' prior: 0!
A function with two arguments.
!

!XeFunctionWithTwoArgumentsScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:47'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int fooand(sqInt x, sqInt y);'.
	expected << 'int fooand(sqInt x, sqInt y){'.
	expected << '}'.
	^ expected! !

!XeFunctionWithTwoArgumentsScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/13/2012 00:15'!
foo: x and: y
	<returnType: #int>
	! !

Object subclass: #XeIfFalseAsArgumentInFunctionCallScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeIfFalseAsArgumentInFunctionCallScenario commentStamp: '<historical>' prior: 0!
self bar: (condition ifFalse: [ stmts. lastStmt. ])
==>
bar( (!!(condition) ? lastStmt : 0) )
!

!XeIfFalseAsArgumentInFunctionCallScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/25/2012 19:11'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int bar(int y);'.
	expected << 'int foo(void);'.
	expected << 'int bar(int y){'.
	expected indentation: 1.
	expected << 'return y + 1;'.
	expected indentation: 0.
	expected << '}'.
	expected << 'int foo(void){'.
	expected indentation: 1.
	expected << 'return bar((!!(0) ? 2 : 0));'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeIfFalseAsArgumentInFunctionCallScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/25/2012 19:02'!
bar: y
	<returnType: #int>
	<var: #y type: #int>
	^ y + 1! !

!XeIfFalseAsArgumentInFunctionCallScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/25/2012 19:03'!
foo
	<returnType: #int>
    	^ self bar:  ( false ifFalse: [ 2 ] )! !

Object subclass: #XeIfFalseAsArgumentInReturnScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeIfFalseAsArgumentInReturnScenario commentStamp: '<historical>' prior: 0!
^ condition ifFalse: [ stmts. lastStmt. ]
==>
 return (!!(condition) ? lastStmt : 0)
!

!XeIfFalseAsArgumentInReturnScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/16/2012 22:46'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int foo(void);'.
	expected << 'int foo(void){'.
	expected indentation: 1.
	expected << 'return (!!(0) ? 2 : 0);'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeIfFalseAsArgumentInReturnScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/16/2012 22:45'!
foo
	<returnType: #int>
	^ false
		ifFalse: [ 2 ]! !

Object subclass: #XeIfFalseIfTrueScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeIfFalseIfTrueScenario commentStamp: 'BernardoContreras 5/12/2012 00:58' prior: 0!
condition 
	ifFalse: [ FalseStmts. ]
	ifTrue: [ TrueStmts. ]
==>
if (condition){
	FalseStmts;
} else {
	TrueStmts;
}!

!XeIfFalseIfTrueScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/13/2012 04:46'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'if (!!(1)) {'.
	expected indentation: 2.
	expected << '21;'.
	expected << '} else {'.
	expected indentation: 2.
	expected << '22;'.
	expected << '}'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeIfFalseIfTrueScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/1/2012 15:21'!
foo
	<returnType: #void>
	true
		ifFalse: [ 21 ]
		ifTrue: [ 22 ]! !

Object subclass: #XeIfFalseScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeIfFalseScenario commentStamp: 'BernardoContreras 5/12/2012 01:55' prior: 0!
condition ifFalse: [ stmts. ]
==>
if (!!(condition)){
	stmts;
}
!

!XeIfFalseScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/13/2012 04:44'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'if (!!(0)) {'.
	expected indentation: 2.
	expected << '0;'.
	expected << '}'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeIfFalseScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/1/2012 15:21'!
foo
	<returnType: #void>
	false
		ifFalse: [ 0 ]! !

Object subclass: #XeIfTrueAsArgumentInFunctionCallScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeIfTrueAsArgumentInFunctionCallScenario commentStamp: '<historical>' prior: 0!
self bar: (condition ifTrue: [ stmts. lastStmt. ])
==>
bar( (condition ? lastStmt : 0) )

!

!XeIfTrueAsArgumentInFunctionCallScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/25/2012 19:57'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int bar(int y);'.
	expected << 'int foo(void);'.
	expected << 'int bar(int y){'.
	expected indentation: 1.
	expected << 'return y + 1;'.
	expected indentation: 0.
	expected << '}'.
	expected << 'int foo(void){'.
	expected indentation: 1.
	expected << 'return bar((0 ? 2 : 0));'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeIfTrueAsArgumentInFunctionCallScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/25/2012 19:56'!
bar: y
	<returnType: #int>
	<var: #y type: #int>
	^ y + 1! !

!XeIfTrueAsArgumentInFunctionCallScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/25/2012 19:57'!
foo
	<returnType: #int>
    	^ self bar:  ( false ifTrue: [ 2 ] )! !

Object subclass: #XeIfTrueAsArgumentInReturnScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeIfTrueAsArgumentInReturnScenario commentStamp: '<historical>' prior: 0!
^ condition ifTrue: [ stmts. lastStmt. ]
==>
return  (condition ? lastStmt : 0)
!

!XeIfTrueAsArgumentInReturnScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/20/2012 16:42'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int foo(void);'.
	expected << 'int foo(void){'.
	expected indentation: 1.
	expected << 'return (1 ? 2 : 0);'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeIfTrueAsArgumentInReturnScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/20/2012 16:41'!
foo
	<returnType: #int>
	^ true
		ifTrue: [ 2 ]! !

Object subclass: #XeIfTrueIfFalseScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeIfTrueIfFalseScenario commentStamp: 'BernardoContreras 5/12/2012 00:47' prior: 0!
condition 
	ifTrue: [ TrueStmts. ]
	ifFalse: [ FalseStmts. ]
==>
if (condition){
	TrueStmts;
} else {
	FalseStmts;
}
!

!XeIfTrueIfFalseScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/13/2012 04:50'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'if (1) {'.
	expected indentation: 2.
	expected << '21;'.
	expected << '} else {'.
	expected indentation: 2.
	expected << '22;'.
	expected << '}'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeIfTrueIfFalseScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/1/2012 15:20'!
foo
	<returnType: #void>
	true
		ifTrue: [ 21 ]
		ifFalse: [ 22 ]! !

Object subclass: #XeIfTrueScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeIfTrueScenario commentStamp: 'BernardoContreras 5/12/2012 01:55' prior: 0!
condition ifTrue: [ stmts. ]
==>
if (condition){
	stmts;
}
!

!XeIfTrueScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/13/2012 04:43'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'if (1) {'.
	expected indentation: 2.
	expected << '0;'.
	expected << '}'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeIfTrueScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/1/2012 15:18'!
foo
	<returnType: #void>
	true
		ifTrue: [ 0 ]! !

Object subclass: #XeWhileFalseDoScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeWhileFalseDoScenario commentStamp: 'BernardoContreras 5/11/2012 22:49' prior: 0!
[ stmt.
  lastStmt ] whileFalse: [ stmt2. ]
==>
while (1){
	{	
		stmt;
		if (lastStmt) break;
	}
	stmt2;
}!

!XeWhileFalseDoScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/13/2012 04:51'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'while (1) {'.
	expected indentation: 3.
	expected << '{'.
	expected << 'if (0) break;'.
	expected << '}'.
	expected indentation: 2.
	expected << '2;'.
	expected << '}'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeWhileFalseDoScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/12/2012 20:28'!
foo
	<returnType: #void>
	[ false ] whileFalse: [ 2 ]
 ! !

Object subclass: #XeWhileFalseScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeWhileFalseScenario commentStamp: 'BernardoContreras 5/12/2012 01:37' prior: 0!
[ stmt.
  lastStmt ] whileFalse
==>
while (1){
	stmt;
	if (lastStmt) break;
}!

!XeWhileFalseScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/13/2012 04:51'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'while (1) {'.
	expected indentation: 2.
	expected << 'if (1) break;'.
	expected << '}'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeWhileFalseScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/12/2012 01:49'!
foo
	<returnType: #void>
	[ true ] whileFalse! !

Object subclass: #XeWhileTrueDoScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeWhileTrueDoScenario commentStamp: 'BernardoContreras 5/11/2012 22:43' prior: 0!
[ stmt.
  lastStmt ] whileTrue: [ stmt2. ]
==>
while (1){
	{	
		stmt;
		if (!!(lastStmt)) break;
	}
	stmt2;
}!

!XeWhileTrueDoScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/13/2012 04:51'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'while (1) {'.
	expected indentation: 2.
	expected indentation: 3.
	expected << '{'.
	expected << 'if (!!(1)) break;'.
	expected << '}'.
	expected indentation: 2.
	expected << '2;'.
	expected << '}'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeWhileTrueDoScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/12/2012 20:28'!
foo
	<returnType: #void>
	[ true ] whileTrue: [ 2 ]
 ! !

Object subclass: #XeWhileTrueScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeWhileTrueScenario commentStamp: 'BernardoContreras 5/11/2012 22:44' prior: 0!
[ stmt.
  lastStmt ] whileTrue
==>
while (1){
	stmt;
	if (!!(lastStmt)) break;
}
!

!XeWhileTrueScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/13/2012 04:51'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'while (1) {'.
	expected indentation: 2.
	expected << 'if (!!(1)) break;'.
	expected << '}'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeWhileTrueScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/1/2012 23:44'!
foo
	<returnType: #void>
	[ true ] whileTrue! !
